#include <u.h>
#include <libc.h>

double
calc_list(char **l, double v, char wa)
{
	double b;
	char fir;

	fir = 'y';
	wa = *(*l - 1);

	while(**l != ')') {
		while(**l && (**l < '0' || **l > '9') && **l != '-'
			&& **l != '(' && **l != ')')
			(*l)++;

		if(!**l || **l == ')')
			return v;
		if(**l == '(') {
			(*l) += 2;
			b = calc_list(l, 0, '\0');
		} else {
			b = strtod(*l, (char **)nil);

			while(**l && **l != ' ' && **l != '\t' && **l != '\n'
				&& **l != ')')
				(*l)++;
			(*l)--;
		}

		if(fir == 'y') {
			v = b;
			fir = 'n';
		} else {
			switch(wa) {
				case '/':
					v /= b;
					break;
				case '*':
					v *= b;
					break;
				case '+':
					v += b;
					break;
				case '-':
					v -= b;
					break;
				default:
					return v;
			}
		}
		(*l)++;
	}
	return v;
}

int
main(int argc, char *argv[])
{
	uchar i;
	char *r, **t;

	if(argc > 1)
	{
		r = strdup(argv[1]);
	} else {
		r = mallocz(256, 2);
		i = 0;

		while(read(0, &r[i++], 1) > 0 && i < 255)
			if(r[i - 1] == '\n')
				break;
	}

	t = mallocz(sizeof(char **), 2);
	*t = r + 2;
	print("%f\n", calc_list(t, 0.0f, '\0'));

	free(t);
	free(r);
	exits(0);
	return 0;
}

